local notes = {}
notes.sources = {}

local args = {...}

local round = function(n) return math.floor(n+.5) end

local dec = function(x)
	return x - math.floor(x)
end

local sin = math.sin

local pi = math.pi

local down = math.floor

local up = math.ceil

local sqrt = math.sqrt

local abs = math.abs

functions = {}
functions.sine = function(s, v) return (sin(s/((44100/v))*pi*2)) end
functions.square=function(s, v) local ssin = sin(s/((44100/v))*pi*2); return ssin >0 and 1 or ssin<0 and -1 or 0 end
functions.triang = function(s, v) return abs((s*2)/(44100/v)) end

if not (args[1] == 'sine' or args[1] == 'square' or args[1] == 'triang' or love.filesystem.exists(args[1])) then

	error("Argument must be either 'sine', 'square', 'triang' or a valid filename - got " .. tostring(args[1]))
	
end

if (args[1] == 'sine' or args[1] == 'square' or args[1] == 'triang') then

	notes.a4 = 440
	notes.diff = (2^(1/12))
	notes[49] = notes.a4
	for i = 48, 1, -1 do
		notes[i] = notes[i+1]/notes.diff
	end

	for i = 50, 92 do
		notes[i] = notes[i-1]*notes.diff
	end

	notes.soundDatas = {}
	for i, v in ipairs(notes) do
		notes.soundDatas[i] = love.sound.newSoundData( 441000, 44100, 16, 1)
		for s = 0, 440999 do
			local sin = functions[args[1]](s, v)
			notes.soundDatas[i]:setSample(s, sin)
		end
	end

	notes.sources = {}
	for i, v in ipairs(notes.soundDatas) do
		notes.sources[i] = love.audio.newSource(v)
		notes.sources[i]:setLooping''
	end
	
else

	local diff = 2^(1/12)
	for i = 1, 92 do
		notes.sources[i] = love.audio.newSource(args[1])
		notes.sources[i]:setPitch(diff^(i-49))
		notes.sources[i]:setVolume(args[2] or 1)
	end
	
end

return notes